void sendWebPageChunkedBegin() {
    server.sendHeader(F("Cache-Control"),F("no-cache, no-store, must-revalidate"));
    server.sendHeader(F("Pragma"), F("no-cache"));
    server.sendHeader(F("Expires"), "-1");
    server.setContentLength(CONTENT_LENGTH_UNKNOWN); // *** BEGIN ***
    server.send(200, F("text/html"), "");
}

#define MAXSIZECH 1300

void sendWebPageChunkedData(PGM_P str) {
	String data=String(FPSTR(str));
	sendWebPageChunkedData(data);
}

void sendWebPageChunkedData(const String &data)
{
  String tmp;
  delay(20);
  if (data.length() > 0) {
     //do chunked transfer encoding ourselfs (WebServer doesnt support it)
	unsigned int i = 0;
	unsigned int memory = 0; 
	unsigned int timeout = 0;

	// split into chunks of MAXSIZECH
	for (unsigned int l = 0; l < (data.length() / MAXSIZECH);l++) {
		tmp = data.substring(i, i+ MAXSIZECH);			// prepare tmp string for passing to sendContent()
 		
 		memory = ESP.getFreeHeap();					// available memory before send
		timeout = 0; 								// init timeout
		server.sendContent(tmp);
 		i = i + MAXSIZECH;
		while ((ESP.getFreeHeap() <= memory)&&(timeout <100)) {	// wait for memory to return or the timeout
			delay(5);	
			timeout++;				
			}
		}
		
	// send remainder	
	tmp = data.substring(i, data.length());
	timeout = 0;
	memory = ESP.getFreeHeap();					// available memory befor send
	server.sendContent(tmp);
	while ((ESP.getFreeHeap() < memory) && (timeout <50)) {	// wait for memory to return
		delay(5);
		timeout++;
	}

    // data = F("");   //free RAM
    tmp = F("");
  }
}


void sendWebPageChunkedEnd()
{
   server.sendContent("");
   server.client().flush();
   server.client().stop();
}

void monitorWiFi()
{
  if (wifiMulti.run() != WL_CONNECTED)
  {
    if (connectioWasAlive == true)
    {
      connectioWasAlive = false;
      Serial.print("Looking for WiFi ");
    }
    Serial.print(".");
    delay(500);
  }
  else if (connectioWasAlive == false)
  {
    connectioWasAlive = true;
    Serial.printf(" connected to %s\n", WiFi.SSID().c_str());
  }
}